%global debug_package %{nil}

%define rpm_name		%{name}-%{version}
%define rpm_build_dir_name	${RPM_BUILD_DIR}/%{rpm_name}
%define opt_cpuras		/opt/FJSVxos/cpuras
%define depends_cpuras		%{rpm_build_dir_name}/depends

%define xos_krn_git_url		git@xtc-gitlab.soft.fujitsu.com:postK_ARM_soft/exa_kernel.git
%define krn_name		exa_kernel
%define krn_ver			%{xos_krn_ver}

%define cpuras_git_url		%{xos_com_git_url}
%define cpuras_git_tag		%{xos_com_git_tag}

%define os_exa_git_url		git@xtc-gitlab.vpdc.sg.soft.fujitsu.com:postK_soft/os_exa.git

%define fexdump_git_url		git@xtc-gitlab.vpdc.sg.soft.fujitsu.com:postK_ARM_soft/fexdump.git
%define fexdump_git_tag		develop

Name:FJSVxoscpuras
Version:%{pkg_version}
Release:        %{pkg_revision}%{?dist}
Summary:cpu-mem-ras driver
Group:System Environment/Kernel
License:GPLv2
#URL:
#Sourceタグが定義されていないとsrpmが作れない
Source:%{name}-%{version}.tar.gz 

#BuildRoot:     %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
#BuildRequires:
#Requires: FJSVxosbmc FJSVxoskdump
#Requires: FJSVxosbmc FJSVxosrdump
#Patch01:hoge.patch

%description
This package provides cpu-mem-ras driver relevant drivers.
Version coexistence: possible
  Previous version: 0.0.6-1.el8 and over
  Same version range: node
After updating: warm reboot
Relation package: none

%prep
rm -rf %{rpm_build_dir_name}
rm -rf ${RPM_BUILD_ROOT}

#make the source tar.gz file
#-bsオプションでsrpmを作成しようとすると、%prepが実行されないため、以下のgit archiveコマンドで作った
#ソースファイルが巻かれないので、srpmを作りたい時は、-baで作成する必要がある
#pushd ${RPM_SOURCE_DIR}
#git archive --format=tar.gz --prefix %{name}-%{version}/ --output %{name}-%{version}.tar.gz --remote %{cpuras_git_url} %{cpuras_git_tag}
#popd

#after extracts tar.gz, move to %{name}-%{version} dir
%setup

%build
#driver module compile
#now, current dir is %{name}-%{version}
#cpu-mem-ras module compilea
pushd src
ARCH=arm64 CROSS_COMPILE=%{?xos_cross_compile} KDIR=%{xos_krn_dir} make
popd

%install
rm -rf ${RPM_BUILD_ROOT}

#cpu-mem-ras driver install
mkdir -p ${RPM_BUILD_ROOT}/lib/modules/%{krn_ver}/extra/cpuras
install -p -m 644 %{rpm_build_dir_name}/src/cpu_mem_ras.ko ${RPM_BUILD_ROOT}/lib/modules/%{krn_ver}/extra/cpuras

#startup install
mkdir -p ${RPM_BUILD_ROOT}/%{opt_cpuras}/etc
install -p -m 755 %{rpm_build_dir_name}/script/FJSVxoscpuras ${RPM_BUILD_ROOT}/%{opt_cpuras}/etc

#service install
mkdir -p ${RPM_BUILD_ROOT}/etc/systemd/system
install -p -m 644 %{rpm_build_dir_name}/script/FJSVxoscpuras.service ${RPM_BUILD_ROOT}/etc/systemd/system

#fmaras install
mkdir -p ${RPM_BUILD_ROOT}/etc/cron.daily
install -p -m 500 %{rpm_build_dir_name}/fmaras/etc/cron.daily/fmacheck_acore.sh ${RPM_BUILD_ROOT}/etc/cron.daily

# prealloc
mkdir -p ${RPM_BUILD_ROOT}/etc/opt/FJSVtcs/prm/syshook/os/cpuras
install -p -m 500 %{rpm_build_dir_name}/fmaras/etc/opt/FJSVtcs/prm/syshook/os/cpuras/prealloc ${RPM_BUILD_ROOT}/etc/opt/FJSVtcs/prm/syshook/os/cpuras

# postfree
install -p -m 500 %{rpm_build_dir_name}/fmaras/etc/opt/FJSVtcs/prm/syshook/os/cpuras/postfree ${RPM_BUILD_ROOT}/etc/opt/FJSVtcs/prm/syshook/os/cpuras

# syshook.conf
install -p -m 600 %{rpm_build_dir_name}/fmaras/etc/opt/FJSVtcs/prm/syshook/os/cpuras/syshook.conf ${RPM_BUILD_ROOT}/etc/opt/FJSVtcs/prm/syshook/os/cpuras

# fma
mkdir -p ${RPM_BUILD_ROOT}/%{opt_cpuras}/sbin
install -p -m 500 %{rpm_build_dir_name}/fmaras/opt/FJSVxos/cpuras/sbin/fma.v181130 ${RPM_BUILD_ROOT}/%{opt_cpuras}/sbin

%clean
rm -rf %{buildroot}

%pre
if [ "$1" = "2" ]
then
#perform when upgrade(rpm -U).
systemctl disable FJSVxoscpuras
fi

%post
systemctl enable FJSVxoscpuras
/sbin/depmod -a

%preun
if [ "$1" = "0" ]
then
#perform when elase(rpm -e) only.
systemctl disable FJSVxoscpuras
/sbin/depmod -a
fi


%files

%defattr(644,root,root,-)
/etc/systemd/system/FJSVxoscpuras.service
/lib/modules/%{krn_ver}/extra/cpuras/cpu_mem_ras.ko

%defattr(755,root,root,-)
%{opt_cpuras}/etc/FJSVxoscpuras

%defattr(500,root,root,-)
/etc/cron.daily/fmacheck_acore.sh
/etc/opt/FJSVtcs/prm/syshook/os/cpuras/prealloc
/etc/opt/FJSVtcs/prm/syshook/os/cpuras/postfree
%{opt_cpuras}/sbin/fma.v181130

%defattr(600,root,root,-)
/etc/opt/FJSVtcs/prm/syshook/os/cpuras/syshook.conf

%changelog

